/*
** tlshash.h for tlsinject in
**
** Made by Averous Julien-Pierre
** E-Mail   <j.averous@sourcemac.com>
**
** Started on  Wed Nov 26 13:56:40 2008 Averous Julien-Pierre
** Last update Sat Dec  6 19:28:58 2008 Averous Julien-Pierre
*/

#ifndef TLSHASH_H_
# define TLSHASH_H_

# include <pthread.h>

# define TABLE_SIZE 500

/*
** Types
*/
typedef struct tls_hash_item_ tls_hash_item;
typedef struct tls_hash_  tls_hash;

typedef void (*hash_free_item)(tls_hash *, void *);

/*
** Structures
*/
/// An internal object to link an user object with its key in the hash table
struct tls_hash_item_
{
  long long	key;		/*!< The key of the user object*/
  void		*content;	/*!< The user object*/

  struct tls_hash_item_ *next;
};

/// The hash object
struct tls_hash_
{
  pthread_mutex_t	mutex;	/*!< A mutex to protect our hash table*/
  tls_hash_item		**array; /*!< The hash table*/

  hash_free_item       	free_foo; /*!< A user function to free an user object*/
};

/*
** Functions
*/
void tls_hash_init(tls_hash *table, hash_free_item freer);
void tls_hash_clean(tls_hash *table);

void tls_hash_set_content(tls_hash *table, long long key, void *content);
void *tls_hash_get_content(tls_hash *table, long long key);

void tls_hash_remove(tls_hash *table, long long key);

void tls_hash_print(tls_hash *table);

#endif /* !TLSHASH_H_ */
